local selectButton = THEME:GetString('GameButton', 'Select')
local bodyText = {
    THEME:GetString('ScreenSetup', '300Text1'),
    string.format(THEME:GetString('ScreenSetup', '300Text2'), selectButton),
    THEME:GetString('ScreenSetup', '300Text3'),
    THEME:GetString('ScreenSetup', '300Text4'),
}
local graphicPath = 'Screen draw/Graphics/feature/300/'

local lang = THEME:GetCurLanguage()
local current = 0
local text = ''
return Def.ActorFrame({
    Def.Sprite({
        InitCommand = function(self)
            self:LoadBackground(W_CUSTOM:Path(string.format('%s%s.png', graphicPath, 1)))
            self:scaletofit(-SCREEN_CENTER_X, -100, SCREEN_CENTER_X, 100)
            self:y(-80)
        end,
        ChangedPageMessageCommand = function(self, params)
            local value = ''
            if params.Value then
                value = '_'..params.Value
            end
            self:stoptweening()
            self:diffusealpha(0)
            self:LoadBackground(W_CUSTOM:Path(string.format('%s%s%s.png', graphicPath, params.Page, value)))
            self:scaletofit(-SCREEN_CENTER_X, -100, SCREEN_CENTER_X, 100)
            self:y(-80)
            self:linear(0.2)
            self:diffusealpha(1)
        end,
        ChangedValueMessageCommand = function(self, params)
            self:playcommand('ChangedPage', params)
        end,
    }),
    -- 左右の矢印（選曲ホイールから拝借）
    Def.ActorFrame({
        InitCommand=function(self)
            self:zoom(2)
            self:y(-70)
        end,
        ChangedPageMessageCommand = function(self, params)
            self:visible(not not params.Value)
        end,
        LoadActor(THEME:GetPathG('ScreenSelectMusic/wheel/frame', 'over'), 180, 'timer'),
    }),
    Def.ActorFrame({
        InitCommand = function(self)
            self:xy(-310, 50)
        end,
        Def.Actor({
            ChangedPageMessageCommand = function(self, params)
                text = bodyText[params.Page] or ''
                current = 0
            end,
        }),
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                self:xy(-1, -1)
                self:zoomto(622, 142)
                self:diffuse(1, 1, 1, 0.5)
            end,
        }),
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                self:zoomto(620, 140)
                self:diffuse(0, 0, 0, 0.85)
            end,
        }),
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                self:zoomto(10, 20)
                self:diffuse(1, 1, 1, 0)
            end,
            ChangedPageMessageCommand = function(self, params)
                self:finishtweening()
                self:xy(5, 5)
                self:queuecommand('Animation')
            end,
            AnimationCommand = function(self)
                local textList = split('\n', text)
                local function Move(self, curLine)
                    if curLine > #textList-1 then return end
                    local moveX = math.min(string.len(textList[curLine])*5, 600)
                    self:diffusealpha(0.5)
                    self:linear(string.len(textList[curLine]) * 0.0019)
                    self:addx(moveX)
                    self:diffusealpha(0)
                    self:sleep(0.001)
                    self:addx(-moveX)
                    self:addy(21)
                end
                self:diffuse(1, 1, 1, 0.3)
                self:sleep(0.05)
                self:diffuse(1, 1, 1, 0)
                self:sleep(0.05)
                self:diffuse(1, 1, 1, 0.3)
                self:sleep(0.05)
                --self:diffuse(1, 1, 1, 0)
                Move(self, 1)
                Move(self, 2)
                Move(self, 3)
                Move(self, 4)
                Move(self, 5)
                Move(self, 6)
            end,
        }),
        LoadFont('Common Normal')..{
            Text = bodyText[1] or '',
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(top)
                self:xy(10, 10)
                self:zoom(0.66)
                self:vertspacing(10)
                self:wrapwidthpixels(600/0.66)
            end,
            ChangedPageMessageCommand = function(self, params)
                self:stoptweening()
                self:settext('')
                self:sleep(0.2)
                self:queuecommand('Clear')
            end,
            ClearCommand = function(self)
                self:diffuse(0, 0, 0, 0.1)
                self:settext(text)
                self:queuecommand('Trans')
            end,
            TransCommand = function(self)
                self:stoptweening()
                self:AddAttribute(0, {Length = current, Diffuse = color('1, 1, 1, 1')})
                self:sleep(0.005)
                if current < string.len(text) then
                    current = current + 1
                    self:queuecommand('Trans')
                end
            end,
        }
    }),
})