local screenName = Var('LoadingScreen')
local config = LoadActor(THEME:GetPathO('', 'Frame/config'))
local default = config.Default
local frameName = W_OPTION:ReadPref('GameFrame', default)
local frameList = config.List

if GAMESTATE:IsDemonstration() and screenName ~= 'ScreenJukebox' then
    frameName = default
end

if frameName == 'Random' then
    local r = math.random(0, #frameList)
    frameName = (r == 0) and default or frameList[r]
end


local function FrameActor(frameName)
    if frameName == default then
        setenv('WAIEI_JUDGMENT_FONT', {})
        W_OPTION:UpdateRedir('Graphics/HoldJudgment label 1x2.redir', 'ScreenGameplay/judgment/Hold')
        return LoadActor(THEME:GetPathG('', 'ScreenGamePlay/_parts/frame'))
    end
    local frame = LoadActor(THEME:GetPathO('', 'Frame/'..string.lower(frameName)), frameName)
    W_OPTION:UpdateRedir(
        'Graphics/HoldJudgment label 1x2.redir',
        string.format('../Other/Frame/_judgment/%s/Hold 1x2 (doubleres).png', frame.Font and frame.Font.File or '')
    )
    setenv('WAIEI_JUDGMENT_FONT', frame.Font or {})
    return frame.Actor
end

return Def.ActorFrame({
    FrameActor(frameName)
})