-- 発光エフェクト
local function LightActor(pn)
    return Def.ActorFrame({
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0.2, 0.5, 0.6, 0.9)
                self:diffuselowerright(0.2, 0.5, 0.6, 0)
                self:faderight(1)
                self:zoomto(SCREEN_WIDTH/2, 30)
                self:horizalign(left)
                self:vertalign(top)
                self:xy(SCREEN_LEFT, SCREEN_TOP)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0.2, 0.5, 0.6, 0.9)
                self:diffuseupperright(0.2, 0.5, 0.6, 0)
                self:faderight(1)
                self:zoomto(SCREEN_WIDTH/2, 30)
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy(SCREEN_LEFT, SCREEN_BOTTOM)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0.2, 0.5, 0.6, 1)
                self:diffuselowerright(0, 0, 0, 0.5)
                self:faderight(1)
                self:zoomto(SCREEN_WIDTH/2, 30)
                self:blend('BlendMode_Add')
                self:horizalign(left)
                self:vertalign(top)
                self:xy(SCREEN_LEFT, SCREEN_TOP)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0.2, 0.5, 0.6, 1)
                self:diffuseupperright(0, 0, 0, 0.5)
                self:faderight(1)
                self:zoomto(SCREEN_WIDTH/2, 30)
                self:blend('BlendMode_Add')
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy(SCREEN_LEFT, SCREEN_BOTTOM)
            end,
        }),
        OnCommand = function(self)
            self:rotationy(W:IsP1(pn) and 0 or 180)
            self:x(W:IsP1(pn) and 0 or SCREEN_WIDTH)
        end,
        CustomFrameUpdateCommand = function(self, params)
            if params.Player == pn then
                if params.Sec >= params.LightSec then
                    self:diffusealpha(0.1*(10 - (((params.Beat+0.1)*10)%10)))
                else
                    self:diffusealpha(0)
                end
            end
        end,
    })
end

return Def.ActorFrame({
    LightActor(PLAYER_1),
    LightActor(PLAYER_2),
})