local width, height = ...
width  = 0.1 * width
height = 0.1 * height
local max   = {100, 100, 100,  70,  50,  55,  70, 100,  90,  60}
local min   = { 65,  70,  40,  30,  30,  30,  50,  75,  60,  40}
local cycle = {100, 100, 100, 100,  90,  75,  75,  50,  50,  50}
local spectrums = Def.ActorFrame({})
-- OF5で追加されたAudioVisualizerを使用する場合はParent
local updateMode = W:IsOFV() and 'Parent' or 'Self'

local avList = {}
if updateMode == 'Parent' then
    spectrums[#spectrums+1] = Def.AudioVisualizer({
        -- 何故か一つ多めに取得しないと値が取れない。しかも[1]は0なのでさらに一つ多めに取得が必要
        Amount = 22, -- The amount of colums, its from min of 16 to a max of 128.
        LinearPeaks = true, -- define if we want lenear peaks, as in a slow animation when it goes back to 0.
        PeakHeight = 100, -- the hight of the columns,
        UpdateRate = 0.02, -- the update rate of the columns, the lower the faster, between 10 and 0.01.
        OnCommand = function(self)
            self:visible(false)
        end,
        ScreenUpdateMessageCommand = function(self)
            local total = 0
            local quads = self:GetQuads()
            local isMono = quads[#quads-2]:GetZoomedHeight() == 0 and quads[#quads-1]:GetZoomedHeight() == 0
            for i,a in pairs(quads) do
                if i > 1 then   -- 何故か1は0なので無視
                    if isMono then
                        avList[i-1] = a:GetZoomedHeight()
                        if i>10 then break end
                    else
                        if i%2 == 0 then
                            total = a:GetZoomedHeight()
                        else
                            avList[math.floor(i/2)] = (total + a:GetZoomedHeight()) / 2
                        end
                    end
                end
            end
        end,
    })
end

for i=0, 9 do
    spectrums[#spectrums+1] = LoadActor(W:Object('spectrum'), {
        Width      = width,
        Height     = height,
        Max        = max[i+1],
        Min        = min[i+1],
        Cycle      = cycle[i+1],
        UpdateMode = updateMode,
    })..{
        InitCommand = function(self)
            self:x((i-4.5) * width)
        end,
        ScreenUpdateMessageCommand = function(self)
            if updateMode == 'Parent' then
                self:playcommand('UpdateSpectrum', {
                    Value = avList[i+1] or 0,
                })
            end
        end,
    }
end
return spectrums
