local wheelZoom = math.min((1.0*SCREEN_WIDTH/854 + 1.0)/2, 1)
local wheelHeight = 90
local wheelItemHeight = wheelHeight-4
local wheelItemWidth = 110
local wheel

return Def.ActorFrame({
    InitCommand = function(self)
        self:y(-12)
    end,
    OffCommand=function(self)
        self:sleep(0.2)
        self:linear(0.2)
        self:addy(SCREEN_HEIGHT-150)
    end,
    -- ホイールフレーム背景
    -- LoadActor(THEME:GetPathG('ScreenSelectMusic/wheel/frame', 'bg'))..{
    --     InitCommand = function(self)
    --         -- 16:9以下のサイズの場合表示サイズを小さくする
    --         self:zoom(wheelZoom)
    --         -- ちょっと上にずれるので補正
    --         self:y(math.max((1.0-wheelZoom)*10, 0))
    --     end,
    -- },
    -- ホイール
    Def.ActorProxy({
        OnCommand=function(self)
            wheel = SCREENMAN:GetTopScreen():GetChild('MusicWheel')
            if wheel then
                self:SetTarget(wheel)
                self:halign(SCREEN_CENTER_X)
                self:valign(SCREEN_CENTER_Y)
                -- 16:9以下のサイズの場合表示サイズを小さくする
                self:zoom(wheelZoom)
                -- ちょっと上にずれるので補正
                self:y(math.max((1.0-wheelZoom)*10, 0))
            end
        end,
    }),
    -- 左右の矢印
    Def.ActorFrame({
        InitCommand=function(self)
            -- 16:9以下のサイズの場合表示サイズを小さくする
            self:zoom(wheelZoom)
            -- ちょっと上にずれるので補正
            self:y(math.max((1.0-wheelZoom)*10, 0))
        end,
        LoadActor(THEME:GetPathG('ScreenSelectMusic/wheel/frame', 'over'), 130),
    }),
    -- スクロールバー
    LoadActor(W:Object('scrollbar'), {
        Id = 'WheelPosition',
        Width  = 1.5,
        Height = 200, --WideScale(200, 200),
        Count  = 1,
        Color  = color('#44bbccff'),
    })..{
        OnCommand = function(self)
            self:xy(0, -65)
            self:rotationz(-90)
            self:playcommand('ScrollMenu', {Init = true, Id = 'WheelPosition',Cursor = wheel:GetCurrentIndex()})
            self:playcommand('UpdateWheelScroll')
        end,
        CurrentSongChangedMessageCommand = function(self, params)
            self:playcommand('UpdateWheelScroll')
        end,
        CurrentCourseChangedMessageCommand = function(self, params)
            self:playcommand('UpdateWheelScroll')
        end,
        UpdateWheelScrollCommand = function(self)
            if wheel then
                self:playcommand('UpdateScrollData', {Id = 'WheelPosition', Length = math.max(wheel:GetNumItems(), 1)})
                self:playcommand('ScrollMenu', {Id = 'WheelPosition',Cursor = wheel:GetCurrentIndex()+1})
            end
        end,
        OffCommand = function(self)
            self:finishtweening()
        end,
    },
})