local tc, tcConfig = ...

-- ライフゲージ
local lifeWidth = WideScale(110, 160)
local function LifeActor(pn)
    local h = 20
    local function BatteryLife()
        local actors = Def.ActorFrame({
            OnCommand = function(self)
                self:zoomx(WideScale(0.78, 1))
                self:x(WideScale(28, 1))
            end,
        })
        if W_PLAYER:IsEnabled(pn) then
            local w = lifeWidth + WideScale(115, 66)
            actors[#actors+1] = Def.Quad({
                OnCommand = function(self)
                    self:zoomto(2+w, 2+h)
                    self:diffuse(0.0, 0.1, 0.2, 0.8)
                    self:horizalign(left)
                    self:diffuse(tcConfig.Color.Frame)
                    self:glowshift()
                    self:effectcolor1(tcConfig.Color.Frame)
                    self:effectcolor2(tcConfig.Color.Frame)
                    self:xy(-1, 0)
                end,
                CustomFrameChangedLifeCommand = function(self, params)
                    if params.Player == pn then
                        if params.Danger then
                            self:effectcolor1(tcConfig.Color.Frame)
                            self:effectcolor2(tcConfig.Color.Danger)
                        else
                            self:effectcolor1(tcConfig.Color.Frame)
                            self:effectcolor2(tcConfig.Color.Frame)
                        end
                    end
                end,
            })
            for i=0, 9 do
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:horizalign(left)
                    end,
                    CustomFrameOnCommand = function(self, params)
                        if params.Player == pn and params.Battery then
                            local total = math.min(math.max(params.Life:GetTotalLives(), 4), 10)
                            if i < total then
                                local s = (w / total)-2
                                self:x(i*(s+2)+2)
                                self:zoomto(s-2, h)
                            else
                                self:x(0)
                                self:zoom(0)
                            end
                            self:visible(i < params.Life:GetTotalLives())
                        end
                    end,
                    CustomFrameChangedLifeCommand = function(self, params)
                        if params.Player == pn and params.Battery then
                            self:stoptweening()
                            self:visible(i < params.Life:GetLivesLeft())
                            if params.Life:GetLivesLeft() <= 1 then
                                self:diffuse(tcConfig.Color.Danger)
                            elseif params.Value>=1.0 then
                                self:diffuse(tcConfig.Color.Hot)
                            else
                                self:diffuse(tcConfig.Color.Battery)
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.95)
                        end
                    end,
                    CustomFrameUpdateCommand = function(self, params)
                        if params.Player == pn and params.Battery then
                            local total = params.Life:GetTotalLives()
                            if params.Value>=1.0 and params.Life:GetLivesLeft() > 1 then
                                self:diffuse(HSV((params.ColorCycle+360-(i*50/total))%360, 0.75, 1))
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.95)
                        end
                    end,
                })
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:horizalign(left)
                        self:blend('BlendMode_Add')
                    end,
                    CustomFrameOnCommand = function(self, params)
                        if params.Player == pn and params.Battery then
                            local total = math.min(math.max(params.Life:GetTotalLives(), 4), 10)
                            if i < total then
                                local s = (w / total)-2
                                self:x(i*(s+2)+2)
                                self:zoomto(s-2, h)
                            else
                                self:x(0)
                                self:zoom(0)
                            end
                            self:visible(i < params.Life:GetTotalLives())
                        end
                    end,
                    CustomFrameUpdateCommand = function(self, params)
                        if params.Player == pn and params.Battery then
                            local total = params.Life:GetTotalLives()
                            self:diffuse(1, 1, 1, ((params.Beat*10+i*(-1.25))%10)*0.01+0.1)
                        end
                    end,
                })
            end
        end
        return Def.ActorFrame({
            OnCommand = function(self)
                self:skewx(-1)
                self:xy(-84, 3)
            end,
            CustomFrameOnCommand = function(self, params)
                if params.Player == pn then
                    self:visible(params.Battery ~= nil)
                end
            end,
            actors,
        })
    end
    local function NormalLife()
        local actors = Def.ActorFrame({
            OnCommand = function(self)
                self:zoomx(WideScale(0.78, 1))
                self:x(WideScale(28, 1))
            end,
        })
        if W_PLAYER:IsEnabled(pn) then
            for i=0, 18 do
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:zoomto(10, 2+h)
                        self:diffuse(0.0, 0.1, 0.2, 0.8)
                        self:horizalign(left)
                        self:diffuse(tcConfig.Color.Frame)
                        self:glowshift()
                        self:effectcolor1(tcConfig.Color.Frame)
                        self:effectcolor2(tcConfig.Color.Frame)
                        self:xy(i*12-1, 0)
                    end,
                    CustomFrameChangedLifeCommand = function(self, params)
                        if params.Player == pn then
                            if params.Danger then
                                self:effectcolor1(tcConfig.Color.Frame)
                                self:effectcolor2(tcConfig.Color.Danger)
                            else
                                self:effectcolor1(tcConfig.Color.Frame)
                                self:effectcolor2(tcConfig.Color.Frame)
                            end
                        end
                    end,
                })
            end
            for i=0, 9 do
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:zoomto(8, h)
                        self:horizalign(left)
                        self:x(i*24)
                    end,
                    CustomFrameChangedLifeCommand = function(self, params)
                        if params.Player == pn then
                            self:stoptweening()
                            if params.LifeColor then
                                self:diffuse(params.LifeColor == 'rainbow'
                                                and HSV(params.ColorCycle, 0.75, 1)
                                                or color(params.LifeColor))
                            elseif params.Value>=1.0 then
                                self:diffuse(tcConfig.Color.Hot)
                            else
                                self:diffuse(tcConfig.Color.Normal)
                            end
                            local base = 0.01*math.floor((params.Value*1000)%100)
                            if params.Value >= 0.1*i+0.095 then
                                self:croptop(0)
                            elseif params.Value < 0.1*(i-1)+0.095 then
                                self:croptop(1)
                            else
                                self:croptop((base >= 0.95) and 1 or math.max(1-base/0.95, 0))
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.95)
                        end
                    end,
                    CustomFrameUpdateCommand = function(self, params)
                        if params.Player == pn then
                            if params.LifeColor then
                                self:diffuse(params.LifeColor == 'rainbow'
                                                and HSV(params.ColorCycle, 0.75, 1)
                                                or color(params.LifeColor))
                            elseif params.Value>=1.0 then
                                self:diffuse(HSV(params.ColorCycle, 0.75, 1))
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.95)
                        end
                    end,
                })
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:zoomto(8, h)
                        self:horizalign(left)
                        self:x(i*24)
                    end,
                    CustomFrameUpdateCommand = function(self, params)
                        if params.Player == pn then
                            local white = 0.04*((params.Beat*5+(19-i))%20)
                            if params.Hot then
                                self:diffusealpha(0.6-math.abs(white-0.4)*1.5)
                            else
                                self:diffusealpha(0.8-white)
                            end
                        end
                    end,
                    CustomFrameChangedLifeCommand = function(self, params)
                        if params.Player == pn then
                            local base = 0.01*math.floor((params.Value*1000)%100)
                            if params.Value >= 0.1*i+0.095 then
                                self:croptop(0)
                            elseif params.Value < 0.1*(i-1)+0.095 then
                                self:croptop(1)
                            else
                                self:croptop((base >= 0.95) and 1 or math.max(1-base/0.95, 0))
                            end
                        end
                    end,
                })
            end
            for i=0, 8 do
                actors[#actors+1] = Def.Quad({
                    OnCommand = function(self)
                        self:zoomto(8, h)
                        self:horizalign(left)
                        self:x(12+i*24)
                        --self:skewx(3)
                    end,
                    CustomFrameChangedLifeCommand = function(self, params)
                        if params.Player == pn then
                            self:stoptweening()
                            if params.LifeColor then
                                self:diffuse(params.LifeColor == 'rainbow'
                                                and HSV(params.ColorCycle, 0.75, 1)
                                                or color(params.LifeColor))
                            elseif params.Value>=1.0 then
                                self:diffuse(tcConfig.Color.Hot)
                            else
                                self:diffuse(tcConfig.Color.Normal)
                            end
                            local base = 0.01*math.floor((params.Value*1000)%100)
                            if params.Value >= 0.1*(i+1) then
                                self:cropbottom(0)
                            elseif params.Value < 0.1*i+0.095 then
                                self:cropbottom(1)
                            else
                                self:cropbottom((base >= 0.95) and math.max(1-(base-0.95)/0.05, 0) or 0)
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.85)
                        end
                    end,
                    CustomFrameUpdateCommand = function(self, params)
                        if params.Player == pn then
                            if params.LifeColor then
                                self:diffuse(params.LifeColor == 'rainbow'
                                                and HSV(params.ColorCycle, 0.75, 1)
                                                or color(params.LifeColor))
                            elseif params.Value>=1.0 then
                                self:diffuse(HSV(params.ColorCycle, 0.75, 1))
                            end
                            local col = self:GetDiffuse()
                            self:diffusebottomedge(BoostColor(col, 2.0))
                            self:diffusealpha(0.85)
                        end
                    end,
                })
            end
        end
        return Def.ActorFrame({
            OnCommand = function(self)
                self:skewx(-1)
                self:xy(-84, 3)
            end,
            CustomFrameOnCommand = function(self, params)
                if params.Player == pn then
                    self:visible(params.Battery == nil)
                end
            end,
            CustomFrameChangedLifeCommand = function(self, params)
                if params.Player == pn then
                    if params.Battery then return end
                end
            end,
            actors,
        })
    end
    
    return Def.ActorFrame({
        OnCommand = function(self)
            self:xy((WideScale(175, 210) * ((pn == PLAYER_1) and -1 or 1)), 20)
            self:zoomx((pn == PLAYER_1) and 1 or -1)
        end,
        Def.ActorFrame({
            OnCommand = function(self)
                self:xy(-lifeWidth/2+25, -7)
            end,
            LoadActor('frame_cover'),
            LoadActor('frame_light')..{
                OnCommand = function(self)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        if params.Sec >= params.LightSec then
                            self:diffusealpha(0.065*(10 - (((params.Beat+0.1)*10)%10)))
                        else
                            self:diffusealpha(0)
                        end
                    end
                end,
            },
        }),
        LoadActor('life_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(0)
                self:horizalign(right)
                self:x(-lifeWidth/2)
            end,
        },
        LoadActor('life_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(2)
                self:horizalign(left)
                self:x(lifeWidth/2)
            end,
        },
        LoadActor('life_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(1)
                self:zoomtowidth(lifeWidth)
            end,
        },
        NormalLife(),
        BatteryLife(),
        Def.ActorFrame({
            OnCommand = function(self)
                self:x(2.5)
                self:skewx(-1)
            end,
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(lifeWidth+137, 2)
                    self:xy(0, 16)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffuseleftedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((1+params.Beat)*10)%20
                        self:cropright(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(lifeWidth+137, 2)
                    self:xy(0, -11)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffuserightedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((1+params.Beat)*10)%20
                        self:cropleft(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(2, 28)
                    self:xy((lifeWidth+137)/2, 2)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffusebottomedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((params.Beat)*10)%20
                        self:croptop(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(2, 28)
                    self:xy(-(lifeWidth+137)/2, 2)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffusetopedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((params.Beat)*10)%20
                        self:cropbottom(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
        }),
        LoadActor('life_overlay')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(0)
                self:horizalign(right)
                self:x(-lifeWidth/2)
            end,
        },
        LoadActor('life_overlay')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(2)
                self:horizalign(left)
                self:x(lifeWidth/2)
            end,
        },
        LoadActor('life_overlay')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(1)
                self:zoomtowidth(lifeWidth)
            end,
        },
        -- フレア
        LoadActor(THEME:GetPathG('', 'ScreenGameplay/_parts/frame/life/icon_flare'))..{
            InitCommand = function(self)
                self:horizalign(W:IsP1(pn) and right or left)
                self:xy(WideScale(-57, -82), -2)
                self:rotationy(((pn == PLAYER_1) and 0 or 180))
                self:animate(false)
                self:setstate(0)
            end,
            CustomFrameChangedFlareCommand = function(self, params)
                if params.Player == pn then
                    if params.Level then
                        self:setstate(params.Level)
                    end
                end
            end,
        },
        LoadFont('Common Square')..{
            Text = 'Normal',
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:diffusealpha(0.75)
                self:horizalign((pn == PLAYER_1) and right or left)
                self:xy(WideScale(-65, -90), -3)
                self:rotationy(((pn == PLAYER_1) and 0 or 180))
                self:zoom(0.4)
                self:maxwidth(48/0.4)
                self:skewx(-0.3)
                self:visible(W_PLAYER:IsEnabled(pn))
            end,
            OnCommand = function(self)
                local po = GAMESTATE:GetPlayerState(pn):GetPlayerOptions('ModsLevel_Preferred')
                local b = po:LifeSetting()
                local m = po:DrainSetting()
                local text = ''
                if b == 'LifeType_Battery' then
                    text = 'Battery'
                else
                    if m == 'DrainType_NoRecover' then
                        text = 'NoRecover'
                    elseif m == 'DrainType_SuddenDeath' then
                        text = 'SuddenDeath'
                    else
                        text = 'Normal'
                    end
                end
                self:settext(string.upper(text))
            end,
            CustomFrameChangedFlareCommand = function(self, params)
                if params.Player == pn then
                    self:visible(not params.Level or (params.Level == 0))
                end
            end,
        },
        -- 数字
        LoadFont('Common Square')..{
            InitCommand = function(self)
                self:diffuse(Color('White'))
                self:strokecolor(Color('Outline'))
                self:horizalign((pn == PLAYER_1) and right or left)
                self:xy(WideScale(-70, -95), 9.5)
                self:rotationy(((pn == PLAYER_1) and 0 or 180))
                self:zoom(0.42)
                self:maxwidth(52/0.42)
            end,
            CustomFrameChangedLifeCommand = function(self, params)
                if params.Player == pn then
                    self:stoptweening()
                    if params.Battery then
                        self:settext(''..params.Life:GetLivesLeft()..' / '..params.Life:GetTotalLives())
                    else
                        if params.Value >= 1 then
                            self:settext('100%')
                        elseif params.Value <= 0 then
                            self:settext(' 0.0%')
                        else
                            self:settextf('% 4.1f%%', params.Value*100)
                        end
                    end
                end
            end,
        },
    })
end

local function ScoreActor(pn)
    if not W_PLAYER:IsEnabled(pn) then return Def.ActorFrame({}) end
    local displayScore = 0
    return Def.ActorFrame({
        OnCommand = function(self)
            self:rotationy((pn == PLAYER_1) and 0 or 180)
            self:xy(50, 0)
        end,
        Def.ActorFrame({
            OnCommand = function(self)
                self:skewx((pn == PLAYER_1) and -1 or 1)
            end,
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(120, 20)
                    self:xy(0, -2.5)
                    self:diffuse(0, 0, 0, 0.5)
                end,
            }),
        }),
        LoadFont('Common Square')..{
            InitCommand = function(self)
                self:diffuse(1, 1, 1, 1)
                self:diffusetopedge(0.85, 0.85, 0.85, 1)
                self:strokecolor(BoostColor(W_PLAYER:Color(pn), 0.5))
                self:settext('')
                self:xy((pn == PLAYER_1) and 2 or -2, -3)
                self:zoom(0.72)
                self:maxwidth(105/0.72)
                self:visible(W_PLAYER:IsEnabled(pn))
            end,
            CustomFrameUpdateCommand = function(self, params)
                if params.Player == pn then
                    local stats = STATSMAN:GetCurStageStats():GetPlayerStageStats(pn)
                    if stats then
                        local currentScore = stats:GetScore()
                        if currentScore > displayScore then
                            displayScore = displayScore + math.ceil((currentScore - displayScore) / 2.5)
                        elseif currentScore < displayScore then
                            displayScore = currentScore
                        end
                        local formatScore = W_STRING:Number(displayScore)
                        local lenScore = string.len(''..displayScore)
                        self:settext(formatScore)
                        self:ClearAttributes()
                        self:AddAttribute(0, {
                            Length = math.max(string.len(formatScore) - (lenScore + math.floor((lenScore-1)/3)), 0),
                            Diffuse = color('#ffffff80'),
                        })
                    end
                end
            end,
        },
    })
end

local function DifficultyActor(pn)
    if not W_PLAYER:IsEnabled(pn) then return Def.ActorFrame({}) end
    local difficulty
    return Def.ActorFrame({
        OnCommand = function(self)
            self:rotationy((pn == PLAYER_1) and 0 or 180)
            self:xy(-115, 5)
        end,
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:horizalign((pn == PLAYER_1) and right or left)
                self:vertalign(bottom)
                self:diffuse(Color('White'))
                self:diffusealpha(0.75)
                self:xy((pn == PLAYER_1) and 50 or -50, -11)
                self:skewx(-0.3)
                self:zoom(0.35)
                self:maxwidth(40/0.35)
            end,
            CustomFrameChangedStepsCommand = function(self, params)
                if params.Player == pn then
                    self:settextf('%s', string.upper(YA_GROUP:MeterType(params.Song)))
                end
            end,
        },
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:horizalign((pn == PLAYER_1) and right or left)
                self:x((pn == PLAYER_1) and 50 or -50)
                self:vertalign(bottom)
                self:zoom(0.45)
                self:maxwidth(50/0.45)
            end,
            CustomFrameChangedStepsCommand = function(self, params)
                if params.Player == pn then
                    local col = W_DIF:Color(params.Difficulty)
                    self:diffuse(col)
                    self:diffusebottomedge((1+col[1])/2, (1+col[2])/2, (1+col[3])/2, col[4])
                    self:strokecolor(BoostColor(W_DIF:Color(params.Difficulty), 0.35))
                    self:settextf('%s', string.upper(W_DIF:Name(params.Difficulty)))
                end
            end,
        },
        LoadFont('custom1 Combo Numbers')..{
            OnCommand = function(self)
                self:vertalign(bottom)
                self:xy((pn == PLAYER_1) and 75 or -75, 3)
                self:zoom(0.7)
                self:maxwidth(40/0.7)
                self:skewx(-0.3)
            end,
            CustomFrameChangedStepsCommand = function(self, params)
                if params.Player == pn then
                    local col = W_DIF:Color(params.Difficulty)
                    self:diffuse(col)
                    self:diffusebottomedge((1+col[1])/2, (1+col[2])/2, (1+col[3])/2, col[4])
                    self:strokecolor(BoostColor(W_DIF:Color(params.Difficulty), 0.35))
                    self:settextf('%d', params.Steps:GetMeter())
                end
            end,
        },
    })
end

local function BPMActor(pn)
    if not W_PLAYER:IsEnabled(pn) then return Def.ActorFrame({}) end
    return Def.ActorFrame({
        OnCommand = function(self)
            self:rotationy(((pn == PLAYER_1) and 0 or 180))
            self:xy(143, 5)
        end,
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:horizalign(center)
                self:zoom(0.5)
                self:maxwidth(45/0.5)
                self:diffuse(Color('White'))
                self:strokecolor(color('#00000020'))
            end,
            CustomFrameUpdateCommand = function(self, params)
                if params.Player == pn then
                    local steps  = W:Steps(pn)
                    local timing = steps and steps:GetTimingData() or nil
                    if timing then
                        local beat = timing:GetBeatFromElapsedTime(params.Sec)
                        local bpm  = timing:GetBPMAtBeat(beat)
                        self:settextf('%d', math.round(bpm))
                    end
                end
            end,
        },
    })
end

local function PlayerNameActor(pn)
    if not W_PLAYER:IsEnabled(pn) then return Def.ActorFrame({}) end
    return Def.ActorFrame({
        OnCommand = function(self)
            self:rotationy(((pn == PLAYER_1) and 0 or 180))
            self:xy(-50, -24)
        end,
        LoadFont('Common Square')..{
            Text = W_PLAYER:Name(pn) or '',
            OnCommand = function(self)
                self:zoom(0.45)
                self:maxwidth(85/0.45)
            end,
        },
    })
end

local function StageActor()
    local w = WideScale(60, 100)
    return Def.ActorFrame({
        OnCommand = function(self)
            self:y(35)
        end,
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(0)
                self:horizalign(right)
                self:x(-w/2)
            end,
        },
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(2)
                self:horizalign(left)
                self:x(w/2)
            end,
        },
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(1)
                self:zoomtowidth(w)
            end,
        },
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:zoom(WideScale(0.45, 0.5))
                self:diffuse(Color('White'))
                self:diffusebottomedge(0.75, 0.75, 0.75, 1.0)
                self:strokecolor(Color('Black'))
            end,
            ChangedGameplaySongMessageCommand = function(self)
                self:settext(W_STAGE:String())
            end,
        },
    })
end

local function SongTitleActor()
    local w = WideScale(60, 45)
    return Def.ActorFrame({
        OnCommand = function(self)
            self:zoom(WideScale(0.9, 1))
            self:y(SCREEN_BOTTOM - WideScale(52, 48))
        end,
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(0)
                self:horizalign(right)
                self:x(-w/2)
                self:zoom(1.3)
            end,
        },
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(2)
                self:horizalign(left)
                self:x(w/2)
                self:zoom(1.3)
            end,
        },
        LoadActor('stage_frame')..{
            OnCommand = function(self)
                self:animate(false)
                self:setstate(1)
                self:zoomtowidth(w)
                self:zoomy(1.3)
            end,
        },
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:zoom(0.45)
                self:diffuse(Color('White'))
                self:diffusebottomedge(0.9, 0.9, 0.9, 1.0)
                self:strokecolor(Color('Outline'))
                self:maxwidth((w+140)/0.45)
                self:y(6)
            end,
            ChangedGameplaySongMessageCommand = function(self, params)
                if params.Song then
                    self:settextf('%s', params.Song:GetDisplayFullTitle())
                else
                    self:settext('')
                end
            end,
        },
        LoadFont('Common Square')..{
            OnCommand = function(self)
                self:zoom(0.4)
                self:diffuse(Color('White'))
                self:diffusebottomedge(0.75, 0.75, 0.75, 1.0)
                self:diffusealpha(0.8)
                self:strokecolor(Color('Outline'))
                self:maxwidth((w+120)/0.4)
                self:y(-6)
            end,
            ChangedGameplaySongMessageCommand = function(self, params)
                if params.Song then
                    self:settextf('%s', params.Song:GetDisplayArtist())
                else
                    self:settext('')
                end
            end,
        },
    })
end

local function PlayerUnderlayActor()
    return Def.ActorFrame({})
end

local function BottomFrameActor(pn)
    return Def.ActorFrame({
        OnCommand = function(self)
            self:zoom(WideScale(0.9, 1))
            self:xy((-SCREEN_CENTER_X + WideScale(130, 180)) * ((pn == PLAYER_1) and 1 or -1), SCREEN_HEIGHT - 25)
            self:rotationy((pn == PLAYER_1) and 0 or 180)
        end,
        Def.ActorFrame({
            OnCommand = function(self)
                self:xy(-42, 7)
            end,
            LoadActor('frame_cover'),
            LoadActor('frame_light')..{
                OnCommand = function(self)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        if params.Sec >= params.LightSec then
                            self:diffusealpha(0.065*(10 - (((params.Beat+0.1)*10)%10)))
                        else
                            self:diffusealpha(0)
                        end
                    end
                end,
            },
        }),
        LoadActor('small_cover')..{
            OnCommand = function(self)
                self:xy(-51, -24)
            end,
        },
        LoadActor('small_cover')..{
            OnCommand = function(self)
                self:xy(125, 5)
            end,
        },
        LoadActor('score_frame'),
        Def.ActorFrame({
            OnCommand = function(self)
                self:x(-2)
                self:skewx(-1)
            end,
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(238, 2)
                    self:xy(0, -16)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffuseleftedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((1+params.Beat)*10)%20
                        self:cropright(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(238, 2)
                    self:xy(0, 11)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffuserightedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((1+params.Beat)*10)%20
                        self:cropleft(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(2, 28)
                    self:xy(-238/2, -2)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffusebottomedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((params.Beat)*10)%20
                        self:croptop(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
            Def.Quad({
                OnCommand = function(self)
                    self:zoomto(2, 28)
                    self:xy(238/2, -2)
                    self:diffuse(0, 0.5, 1, 1)
                    self:diffusetopedge(0, 0.2, 1, 0)
                    self:blend('BlendMode_Add')
                end,
                CustomFrameUpdateCommand = function(self, params)
                    if params.Player == pn then
                        local beat = ((params.Beat)*10)%20
                        self:cropbottom(math.max(1-beat*0.1, 0))
                        self:diffusealpha((beat >= 10) and 1-(beat-10)*0.1 or 1)
                    end
                end,
            }),
        }),
        -- 難易度
        DifficultyActor(pn),
        -- スコア
        ScoreActor(pn),
        -- BPM
        BPMActor(pn),
        LoadActor('score_overlay')..{
            OnCommand = function(self)
                self:xy(0, 0)
            end,
        },
        -- プレイヤー名
        PlayerNameActor(pn),
    })
end

local function PlayerOverlayActor()
    local a = Def.ActorFrame({})
    for _,pn in pairs(PlayerNumber) do
        a[#a+1] = Def.ActorFrame({
            BottomFrameActor(pn),
            -- ライフ
            LifeActor(pn),
        })
    end
    return a
end

-- フレーム背面
local function FrameUnderlayActor()
    return Def.ActorFrame({
        PlayerUnderlayActor(),
    })
end

-- フレーム前面
local function FrameOverlayActor()
    return Def.ActorFrame({
        OnCommand = function(self)
            self:xy(SCREEN_CENTER_X, SCREEN_TOP)
            self:vertalign(top)
        end,
        -- 上フレーム
        -- 下フレーム
        -- ステージ
        StageActor(),
        SongTitleActor(),
        PlayerOverlayActor(),
    })
end

return Def.ActorFrame({
    CustomFrameOnCommand = function(self, params)
        for _,pn in pairs(PlayerNumber) do
            if params.Player == pn then
                if params.Position then params.Position:zoomy(WideScale(1.028, 1.02)):y(-14) end
                if params.Graph then params.Graph:zoomy(WideScale(1.028, 1.02)):y(-14) end
            end
        end
    end,
    FrameUnderlayActor(),
    FrameOverlayActor(),
})